#ifndef _EVALFUNCTION_H_
#define _EVALFUNCTION_H_

void exactint(char type,double *integral)
{
  switch (type)
    {
    case 's':*integral=0.9460830704;break;
    case 'p':*integral=1./6.;break;
    case 't':*integral=-log(cos(1.));break;
    case 'w':*integral=sqrt(0.5)-1./2.*log(sqrt(2.)-1.);break;
    case 'l':*integral=2.*log(2.)-1.;break;
    case 'h':*integral= 0.5123696287;break;
    case 'q':*integral= 2./3.;break;
    case 'b':*integral=1./3.*(2.-cos(2.)-cos(1.));
     }
}

void evalfunction(double x,char type,double *f)
// berechnet f(x) fuer verschiedene Funktionen auf [0,1]
// type=s f(x)=sin x/x
// type=p f(x)=x^5
// type=t f(x)=tan(x)
// type=w f(x)=sqrt(1+x^2)
// type=l f(x)=ln(1+x)
// type=b f(x)=|sin(3*x-2)|
// type=h f(x)=sin(1/(x+0.01))
// type=q f(x)=sqrt(x)
{
  switch (type)
    {
    case 's':
      {
       if (x==0)
	{
         *f=1;
        }
      else
        {
	*f=sin(x)/x;
        }
       break;
      }
    case 'p': *f=x*x*x*x*x;break;
    case 't': *f=tan(x);break;
    case 'w': *f=sqrt(1+x*x);break;
    case 'l': *f=log(1+x);break;
    case 'h': *f=sin(1./(0.01+x));break;
    case 'q': *f=sqrt(x);break;
    case 'b':
      {
        if (3.*x>2.)
	  {
	    *f=sin(3.*x-2.);
	  }
        else
	  {
            *f=sin(2.-3.*x);
	  }
       }
     }
}

#endif
